=== debian/changelog ===
mixxx (2.3.1~dfsg-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster

  [ Dennis Braun ]
  * New upstream version 2.3.1~dfsg
    + Switch to cmake
    + Update Files-Excluded
  * d/control:
    + Update Build-Depends (Closes: #969601)
    + Bump Standards-Version to 4.6.0
    + Add myself as uploader
    + Remove unused ${dist:Depends} from mixxx package
  * Update d/copyright, files and licenses
  * Delete obsolete d/dirs file
  * Update d/mixxx.docs
  * Update d/*.install files
  * Add lintian-overrides
  * Update d/rules, build with cmake, add hardending
  * Add d/salsa-ci.yml
  * Refresh patchset
    + Fix GCC11 build
  * Add d/upstream/metadata
  * Update d/watch file

 -- Dennis Braun <d_braun@kabelmail.de>  Sat, 18 Dec 2021 13:43:34 +0100
