## mixxx 2.3.2~dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -58,7 +58,7 @@
   endif()
 endif()
 
-project(mixxx VERSION 2.3.1)
+project(mixxx VERSION 2.3.2)
 # Work around missing version suffixes support https://gitlab.kitware.com/cmake/cmake/-/issues/16716
 set(MIXXX_VERSION_PRERELEASE "") # set to "alpha-pre" "beta" or ""
