=== debian/changelog ===
mixxx (2.3.2~dfsg-1) unstable; urgency=medium

  * New upstream version 2.3.2~dfsg (Closes: #925933, #1004624)
  * Refresh patchset

 -- Dennis Braun <d_braun@kabelmail.de>  Wed, 16 Feb 2022 22:46:57 +0100
