=== debian/rules ===
#!/usr/bin/make -f

export CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
export CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export QT_SELECT=5

CMAKE_OPTS = -DCMAKE_BUILD_TYPE=Release \
		-DINSTALL_USER_UDEV_RULES=OFF \
		-DKEYFINDER=OFF

%:
	dh $@ -Scmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_OPTS)

override_dh_auto_build:
	dh_auto_build
	docbook-to-man debian/mixxx.sgml > mixxx.1

override_dh_auto_clean:
	rm -rf cache/ linux_build/
	dh_clean config.log src/build.h build/ mixxx.1
	dh_auto_clean
	rm -rf lin*_build/

override_dh_auto_install:
	dh_auto_install
	find $(CURDIR)/debian/tmp \( -name COPYING -o -name Thumbs.db \
		-o -name shifter.sh -o -name '*.xsl' -o -name '*.php' \
		-o -name LICENSE -o -name README \) -exec rm -f {} \;
	find $(CURDIR)/debian/tmp -name '*.js' -exec chmod -x {} \;
	find $(CURDIR)/debian/tmp/usr/share/mixxx/ -type f -exec chmod -x {} \;
